var pcolortext, pcolorbg, pgraphicalq;
var pbordercolor, pbordermode, pborderwidth, pborderleftstyle, pborderrightstyle, pbordertopstyle, pborderbottomstyle;
var pcollapseborders, phidesignatures, psignaturecolor, psiglinkcolor, phidestructdelimiters, pcolorhtmlmsg;
var pmsgtextcolor,pmsgbgcolor;

colors_fg = new Array(MAX_LEVELS);
colors_bg = new Array(MAX_LEVELS);

function getColorsAndPrefs(ishtmlmessage)
{
  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

  var prefstringfg = "quotecolors.fg.l";
  var prefstringbg = "quotecolors.bg.l";
      
  for( var i=0; i<MAX_LEVELS; i++)
  {
    colors_fg[i] = pref.getCharPref(prefstringfg + (i+1));
    colors_bg[i] = pref.getCharPref(prefstringbg + (i+1));
  }

  pcolortext = pref.getBoolPref("quotecolors.colorText");
  pcolorbg = pref.getBoolPref("quotecolors.colorBackground");
  
  // is graphical quoting enabled?
  pgraphicalq = ( pref.getBoolPref("mail.quoted_graphical") ||
                  !pref.getBoolPref("mailnews.display.disable_format_flowed_support") ||
                  ishtmlmessage );

  if(pgraphicalq)
  {
    pbordermode = pref.getIntPref("quotecolors.borderMode");
    var index_borderstyle = pref.getIntPref("quotecolors.borderstyle");
    var borderstyle = arr_borderstyle[index_borderstyle];

    pbordercolor = pref.getCharPref("quotecolors.bordercolor");
    var index_borderwidth = pref.getIntPref("quotecolors.borderwidth");
    pborderwidth=arr_borderwidth[index_borderwidth];
    
    pborderleftstyle = pref.getBoolPref("quotecolors.borderposition.left") ? borderstyle : "none";
    pborderrightstyle = pref.getBoolPref("quotecolors.borderposition.right") ? borderstyle : "none";
    pbordertopstyle = pref.getBoolPref("quotecolors.borderposition.top") ? borderstyle : "none";
    pborderbottomstyle = pref.getBoolPref("quotecolors.borderposition.bottom") ? borderstyle : "none";
  }

  pcollapseborders = pref.getBoolPref("quotecolors.collapseBorders");

  pcolorhtmlmsg = pref.getBoolPref("quotecolors.colorHTMLmessages");

  pmsgtextcolor = pref.getCharPref("quotecolors.messagetextcolor");
  pmsgbgcolor = pref.getCharPref("quotecolors.messagebgcolor");

  phidesignatures = pref.getBoolPref("quotecolors.hidesignatures");
  psignaturecolor = pref.getCharPref("quotecolors.signaturecolor");
  psiglinkcolor = pref.getCharPref("quotecolors.signaturelinkcolor");

  phidestructdelimiters=false;
  if( pref.getBoolPref("quotecolors.hidestructdelimiters") && pref.getBoolPref("mail.display_struct") )
  {
    phidestructdelimiters=true;
  }
}


function setViewQuotecolor()
{

  var content = getMessageBrowser();
  if(!content)
  {
    // maybe we are in print preview
    content = document.getElementById("content");
    if(!content) return;

    // work-around bugs #142062, #233681 in print preview
    content.contentDocument.getElementsByTagName("body")[0].style.backgroundColor="#ffffff";
  }

  var mailmsg = content.contentDocument;
  
  // does not seem to be a valid message
  if(! mailmsg.getElementsByTagName("div").item(0) )
    return;

  var htmlmsg = mailmsg.getElementsByTagName("div").item(0).getAttribute("class")=="moz-text-html";

  getColorsAndPrefs(htmlmsg);

  var msgcontainsquotes=false;
  if( mailmsg.getElementsByTagName("blockquote").item(0) )
    msgcontainsquotes=true;

  var StyleElement = mailmsg.createElement("style");
  StyleElement.type = "text/css";

  var stylecontent="";


  if(msgcontainsquotes)
  {

    const bqselector = "blockquote[type=cite] ";

    if( (htmlmsg && pcolorhtmlmsg) || !htmlmsg)
    {
    
      for(var i=0;i<MAX_LEVELS; i++)
      {
    
        for(var j=0;j<=i;j++) {
          stylecontent += bqselector;
        }
        
        stylecontent += "{";
        
        // text color
        stylecontent += "color:" + ( pcolortext ? colors_fg[i] : "inherit" ) + " !important;";
        
        // background color
        if(pcolorbg)
          stylecontent += "background-color:"+ colors_bg[i] + " !important;";
          
        // only add/style borders if graphical quoting is enabled  
        if(pgraphicalq)
        {
          stylecontent += "border-color:"+ ( (pbordermode==0) ? colors_fg[i] : pbordercolor ) + " !important;";
          stylecontent += "border-width: " + pborderwidth + "em !important;"
          stylecontent += "border-style: "+pbordertopstyle+" "+pborderrightstyle+" "+pborderbottomstyle+" "+pborderleftstyle+" !important;";
            
          if(pcollapseborders)
          {
            if(i>0)
            {
              var leftmargin = (pborderleftstyle=="none") ? 0.5 : 0.5 + pborderwidth;
              var rightmargin = (pborderrightstyle=="none") ? 0.5 : 0.5 + pborderwidth;
              stylecontent += "margin-left:-"+leftmargin+"em;margin-right:-"+rightmargin+"em;";
            }
            else
                stylecontent += "padding: 0em 0.5em 0em 0.5em !important;";  
          }
    
        }
        else
        {
          stylecontent += "border:none !important;";
          stylecontent += "padding:0em !important;";
        }
      
        stylecontent += "}\n";
      }
    
      if(pcollapseborders)
        stylecontent += "blockquote[type=cite] pre{margin-left:0em !important;margin-right:0em !important;}";
    }
  }

  // set other messages styles

  stylecontent += "body{color:"+pmsgtextcolor+";background-color:"+pmsgbgcolor+";}\n";

  if(phidesignatures)
    stylecontent += ".moz-txt-sig, .moz-signature {display:none;}\n";
  else
  {
    stylecontent += ".moz-txt-sig, .moz-signature {color: "+ psignaturecolor +";}\n";
    stylecontent += ".moz-txt-sig > a, .moz-signature > a {color: "+ psiglinkcolor +";}\n";
  }

  if(phidestructdelimiters)
    stylecontent += ".moz-txt-tag {display:none !important;}\n";

  var styletext = document.createTextNode(stylecontent);
  StyleElement.appendChild(styletext);
    
  mailmsg.getElementsByTagName("head")[0].appendChild(StyleElement);
}